/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef MOVE_HH
#define MOVE_HH

#include "DeformationBase.hh"
#include <map>

namespace SharpConstruct
{
	class Move : public DeformationBase
	{
	public:
		Move();

		virtual void ModifyModel();
		virtual void MouseMove( const Gdk::Point& );
		virtual void MouseUp( const Gdk::Point& );

		virtual void Apply();
	protected:
		virtual void draw_handle_( const Axis, const float x,
					   const float y, const float z );

		std::map< Axis, Gdk::Point > handle_down_locs_;
		std::map< Axis, float > transforms_;
		std::map< Axis, float > final_transforms_;
	};
}

#endif
